<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
/**
 *  Sitemap Class
 *  Copyright (c) 2008 - 2013 All Rights Reserved.
 *
 *  Props to Mike's Imagination for the approach
 *  http://www.mikesimagination.net/blog/post/29-Aug-12/Codeigniter-auto-XML-sitemap
 *
 *  Generates sitemap
 */
 
class Maa_sitemap {
 
    // CI instance property
  protected $ci;
 
  /**
   *  Constructor
   */
  public function __construct()
  {
      // Get the CI instance by reference to make the CI superobject available in this library
    $this->ci =& get_instance();
  }
 
  /**
   *  Generate sitemap
   */
  public function create()
  {
	$CI = & get_instance();
    // Begin assembling the sitemap starting with the header
    $sitemap = "<\x3Fxml version=\"1.0\" encoding=\"UTF-8\"\x3F>\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
 
    // Add static pages not in database to sitemap
    // Home page
    $sitemap .= "\t<url>\n\t\t<loc>" . site_url() . "</loc>\n\t</url>\n\n";
    // About page
    $sitemap .= "\t<url>\n\t\t<loc>" . site_url('home') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('advertise') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('corporate') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('subscribtion') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('feedback') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('mobile.htm') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('contactus') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('terms-and-conditions.htm') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('privacy-policy.htm') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('downlink-info.htm') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('shows') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('events') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('serials') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('gallery/working-stills') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('gallery/events') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('gallery/heroines') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('gallery/wallpapers') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('gallery/movie-stills') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('gallery/heroes') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('news') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('comedy') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('music') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('trailers') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('cookery') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('cookery/veg') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('cookery/non-veg') . "</loc>\n\t</url>\n\n";
	$sitemap .= "\t<url>\n\t\t<loc>" . site_url('cookery/others') . "</loc>\n\t</url>\n\n";
 
     // Get all news (records) from database. Load (or autoload) the model
    $CI->load->model('news/news_model');
    $recipes = $CI->news_model->getAllNews();

    // Add each recipe URL to the sitemap while enclosing the URL in the XML <url> tags
    // Since my database tracks the last updated date, I am including that as well - but with the date only in YYYY-MM-DD format
    foreach($recipes as $recipe)
    {
       $sitemap .= "\t<url>\n\t\t<loc>" . site_url('news/' . url_convert($recipe->news_title)) . "</loc>\n";
       $sitemap .= "\t\t<lastmod>" . date('Y-m-y' ,strtotime($recipe->created_date)) . "</lastmod>\n \t</url>\n\n";
    }
	 // Get all gallery (records) from database. Load (or autoload) the model
    $CI->load->model('gallery/gallery_model');
    $recipes = $CI->gallery_model->getAllGallerycat();

    // Add each recipe URL to the sitemap while enclosing the URL in the XML <url> tags
    // Since my database tracks the last updated date, I am including that as well - but with the date only in YYYY-MM-DD format
    foreach($recipes as $recipe)
    {
       $sitemap .= "\t<url>\n\t\t<loc>" . site_url('gallery/'.url_convert($recipe->category_name).'/'.url_convert($recipe->gallery_title)). "</loc>\n";
       $sitemap .= "\t\t<lastmod>" . date('Y-m-y' ,strtotime($recipe->created_date)) . "</lastmod>\n \t</url>\n\n";
    }
	 // Get all serials  (records) from database. Load (or autoload) the model
    $CI->load->model('programs/program_model');
    $recipes = $CI->program_model->getAllPrograms('serials');

    // Add each recipe URL to the sitemap while enclosing the URL in the XML <url> tags
    // Since my database tracks the last updated date, I am including that as well - but with the date only in YYYY-MM-DD format
    foreach($recipes as $recipe)
    {
       $sitemap .= "\t<url>\n\t\t<loc>" . site_url('programs/'.url_convert($recipe->prog_title))."</loc>\n";
       $sitemap .= "\t\t<lastmod>" . date('Y-m-y' ,strtotime($recipe->created_date)) . "</lastmod>\n \t</url>\n\n";
    }
	 $recipes = $CI->program_model->getAllPrograms('shows');

    // Add each recipe URL to the sitemap while enclosing the URL in the XML <url> tags
    // Since my database tracks the last updated date, I am including that as well - but with the date only in YYYY-MM-DD format
    foreach($recipes as $recipe)
    {
       $sitemap .= "\t<url>\n\t\t<loc>" . site_url('programs/'.url_convert($recipe->prog_title))."</loc>\n";
       $sitemap .= "\t\t<lastmod>" . date('Y-m-y' ,strtotime($recipe->created_date)) . "</lastmod>\n \t</url>\n\n";
    }
	$recipes = $CI->program_model->getAllPrograms('events');

    // Add each recipe URL to the sitemap while enclosing the URL in the XML <url> tags
    // Since my database tracks the last updated date, I am including that as well - but with the date only in YYYY-MM-DD format
    foreach($recipes as $recipe)
    {
       $sitemap .= "\t<url>\n\t\t<loc>" . site_url('programs/'.url_convert($recipe->prog_title))."</loc>\n";
       $sitemap .= "\t\t<lastmod>" . date('Y-m-y' ,strtotime($recipe->created_date)) . "</lastmod>\n \t</url>\n\n";
    }
	// Get all cookery (records) from database. Load (or autoload) the model
    $CI->load->model('welcome/home_model');
    $recipes = $CI->home_model->getCookery();

    // Add each recipe URL to the sitemap while enclosing the URL in the XML <url> tags
    // Since my database tracks the last updated date, I am including that as well - but with the date only in YYYY-MM-DD format
    foreach($recipes as $recipe)
    {
       $sitemap .= "\t<url>\n\t\t<loc>" . site_url('cookery/'.url_convert($recipe->cookery_type).'/'.url_convert($recipe->cookery_title)). "</loc>\n";
       $sitemap .= "\t\t<lastmod>" . date('Y-m-y' ,strtotime($recipe->created_date)) . "</lastmod>\n \t</url>\n\n";
    }
	// Get all Trailers (records) from database. Load (or autoload) the model
    $CI->load->model('trailers/trailers_model');
    $recipes = $CI->trailers_model->getAllTrailers('1');

    // Add each recipe URL to the sitemap while enclosing the URL in the XML <url> tags
    // Since my database tracks the last updated date, I am including that as well - but with the date only in YYYY-MM-DD format
    foreach($recipes as $recipe)
    {
       $sitemap .= "\t<url>\n\t\t<loc>" . site_url('trailers/'.url_convert($recipe->trailers_title)). "</loc>\n";
       $sitemap .= "\t\t<lastmod>" . date('Y-m-y' ,strtotime($recipe->created_date)) . "</lastmod>\n \t</url>\n\n";
    }
  //print_r($sitemap);die;
    // If you have other records you wish to include, get those and continue to append URL's to the sitemap.
 
    // Close with the footer
    $sitemap .= "</urlset>\n";
 
    // Write the sitemap string to file. Make sure you have permissions to write to this file.
    $file = fopen('sitemap.xml', 'w');
    fwrite($file, $sitemap);
    fclose($file);
 
    // If this is the production instance, attempt to update Google with the new sitemap.
    // (The instance is set in the index.php file)
    if(ENVIRONMENT === 'production')
    {
      // Ping Google via http request with the encoded sitemap URL
      $sitemap_url = site_url('sitemap.xml');
      $google_url = "http://www.google.com/webmasters/tools/ping?sitemap=".urlencode($sitemap_url);
 
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,2);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
      curl_setopt ($ch, CURLOPT_URL, $google_url);
      $response = curl_exec($ch);
      $http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
 
      // Log error if update fails
      if (substr($http_status, 0, 1) != 2)
      {
        log_message('error', 'Ping Google with updated sitemap failed. Status: ' . $http_status);
        log_message('error', '    ' . $google_url);
      }
    }
 
    return;
  }
}
 
// End of file MY_sitemap
// Location: ./application/libraries/MY_sitemap.php