<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	http://codeigniter.com/user_guide/general/routing.html
| 
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There area two reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router what URI segments to use if those provided
| in the URL cannot be matched to a valid route.
|
*/
$route['timthumb/(:any)/(:any)/(:any)'] = "timthumb.php?w=$1&h=$2&src=$3";

$route['seo/sitemap\.xml'] = "seo";
$route['default_controller'] = "welcome";
$route['About-us'] = "welcome/aboutus";
$route['Services'] = "welcome/services";
$route['Careers'] = "welcome/careers";
$route['Contact-us'] = "welcome/contactus";
$route['Renovation'] = "welcome/renovation";
$route['Installation'] = "welcome/installation";
$route['Freight-Management'] = "welcome/freightmanagement";
$route['Warehousing'] = "welcome/warehousing"; 
$route['images'] = "welcome/images";
 
/* admin section */
$route['admin/([a-zA-Z_-]+)/(:any)'] = '$1/admin/$2';
$route['admin/login'] = 'admin/login';
$route['admin/settings'] = 'admin/settings';
$route['admin/dashboard'] = 'admin/dashboard';
$route['admin/profile'] = 'admin/profile';
$route['admin/uploadImg'] = 'admin/uploadImg';
$route['admin/profileupdate'] = 'admin/profileupdate';
$route['admin/changepassword'] = 'admin/changepassword';
$route['admin/passwordupdate'] = 'admin/passwordupdate';
$route['admin/cpass'] = 'admin/cpass';
$route['admin/loginstatus'] = 'admin/loginstatus';
$route['admin/switchLanguage'] = 'admin/switchLanguage';
$route['admin/logout'] = 'admin/logout';
$route['admin/([a-zA-Z_-]+)'] = '$1/admin/index';
$route['admin'] = 'admin'; 


/* End of file routes.php */
/* Location: ./application/config/routes.php */
