<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Admin extends CI_Controller {

	public function __construct() {
	    parent::__construct();
	    $this->lang->load("admin", language_load());
		$this->lang->load("admin_login", language_load()); 
		$this->lang->load("adminusers", language_load());
		$this->load->model('adminloginmodel');
	}
	
	public function index()
	{ 
        if(adminLoginCheck()){
		 redirect('admin/dashboard','refresh');
	    }
	    $this->session->unset_userdata('admin_user_data');
        $data = array(); 
		$this->load->view("admin/login_layout",$data); 
	}
	
		
	public function uploadImg()
	{
		$name = '';
		$path = '';
		$name = $_FILES["images"]["name"];
		$path = FCPATH."assets/admin/images/profileimages/";

		$sizekb = $_FILES["images"]["size"] / 1024 ;
		$sizemb = $sizekb / 1024;
		$name = time()."_".$name;
		//die($name."--".$path);		
		if(move_uploaded_file( $_FILES["images"]["tmp_name"], $path.$name))
        {
	        echo $name."|".number_format($sizemb, 2, '.', '');
	        exit;
        }
		
	}
	
	public function login()
   {     
	    if(adminLoginCheck()){
		 redirect('admin/dashboard','refresh');
	    }
	    
		$data = array(); 
		$this->form_validation->set_rules('email', 'User Email', 'trim|required|valid_email');
		$this->form_validation->set_rules('password', 'Password', 'required');
		
		$data['email'] = $this->input->post('email');
	    $data['pass'] = $this->input->post('password');
		
		if($this->form_validation->run() == FALSE) { 
			$this->form_validation->set_message('check_database', 'Invalid Username and Password');
			
		} else {
			$user = $this->input->post('email');
			$pass = $this->input->post('password');
			
			$this->load->model('adminloginmodel');
			$result = $this->adminloginmodel->loginAdmin($data['email'],$data['pass']);
			  
			if (!$result) {
				 
				$data['error'] = $this->lang->line("admin_login_error");
				 $this->load->view("admin/login_layout",$data);
			} else {  
			   // permission data start 
				$perm = json_decode($result[0]->role_permissions);
			 // if user is suerp admin
			 if(isset($perm->all)) {
			        $result[0]->role_permissions =  $perm->all;
			 }else {
                  $perm_data= array();
                 
                  if(is_object(($perm)) && count($perm) > 0 )
					foreach($perm as $k=>$v) {
					  foreach($v as $i=>$j) {
						  $perm_data[$k][$i] = 1;
					   }
					} 	 
	                $result[0]->role_permissions =  $perm_data;
	         } 
	            
	            // permission data end 
				 $this->session->set_userdata('admin_user_data', $result[0]); 
				 $this->dashboard();
			}
		}
		 
		 
	}

	public function dashboard()
	{  
	   if(!adminLoginCheck()){
		 redirect('admin','refresh');
	    }
		$data = array(); 
		/*$data['usrsdata'] = $this->adminloginmodel->usrsdata();
		$data['imagesdata'] = $this->adminloginmodel->imagesdata();
		$data['docsdata'] = $this->adminloginmodel->vegcookerydata();
		$data['images'] = $this->adminloginmodel->nonvegcookerydata();
		$data['othercdata'] = $this->adminloginmodel->othercookerydata();*/
		$data['body'] = $this->load->view("admin/dashboard",$data,true); 
		$this->load->view("admin/layout",$data); 
	}
	
	public function profile()
	{  
		if(!adminLoginCheck()){
			redirect('admin/', 'refresh');
		}
		
	   	$data = array();
	   	$temp = $this->session->userdata('admin_user_data');
	   	$this->load->model('adminloginmodel');	
		$data = messageDisplay(); 
		$data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
		$result = $this->adminloginmodel->getRole($temp->admin_id);	
		$data['role_details'] = $result[0];
		$data['body'] = $this->load->view("admin/profile",$data,true); 
		$this->load->view("admin/layout",$data); 
	}
	
	public function profileupdate()
	{
		if(!adminLoginCheck()){
			redirect('admin/', 'refresh');
		}
		
		if($this->uservalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST')
		{
	    $temp = $this->session->userdata('admin_user_data');
		$arr=array();
 		$arr['admin_displayname'] = $this->input->post('displayname');
 		$arr['admin_img']         = $this->input->post('pimg');
		$arr['admin_id']          = $temp->admin_id;//$this->input->post('admin_id');
		$arr['modified_by']       = $temp->admin_id;
		$arr['modified_date']     = date('Y-m-d H:i:s');

		$this->load->model('adminloginmodel');
		$result = $this->adminloginmodel->updateUserdata($arr);	
		
		if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('adminprofile_updated'));
  				 redirect('admin/profile');
			}
			else{
				$this->session->set_userdata('error_msg',$this->lang->line('adminprofile_emailalreadyexits'));
			}										
	   }
	   else
	   {
 		 $this->getForm($this->input->post('admin_id'));    
	   }
	}
	
	public function changepassword()
 	{
 		if(!adminLoginCheck()){
			redirect('admin/', 'refresh');
		}
		
		$data = array();
		$data = messageDisplay(); 
		$data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
		$data['body'] = $this->load->view("admin/changepassword",$data,true); 
 		$this->load->view("admin/layout",$data); 
 	}
 	
	
	public function passwordupdate()
	{		
		if(!adminLoginCheck()){
			redirect('admin/', 'refresh');
		}
		
		if($this->passwordvalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST')
		{
			if($this->input->post('opass') !=  $this->input->post('cpass'))
			{
				$arr=array();
				$temp                  = $this->session->userdata('admin_user_data');
				$arr['opass']          = md5($this->input->post('opass'));
				$arr['pass']           = md5($this->input->post('pass'));
 				$arr['modified_by']    =  $temp->admin_id;
				$arr['modified_date']  = date('Y-m-d H:i:s');

				$this->load->model('adminloginmodel');
				$result = $this->adminloginmodel->updatePassword($arr);	
				
				if($result){
						$this->session->set_userdata('success_msg',$this->lang->line('admin_password_updated'));
						redirect('admin/changepassword');
					}
					else{
						$this->session->set_userdata('error_msg',$this->lang->line('admin_oldpassword_notmatching'));
						redirect('admin/changepassword');
 					}	
		   }
		   else
		   {
			   $this->session->set_userdata('error_msg',$this->lang->line('oldpass_notsame_newpass'));
			   redirect('admin/changepassword');
		   }									
	   }
	   else
	   {
		   redirect('admin/dashboard');
 	   }
	
	}
	

	public function logout()
	{
		$this->session->unset_userdata('admin_user_data');
		$this->session->sess_destroy();
		redirect('admin/', 'refresh');
	}
	
	public function uservalidateForm()
    {
		$this->form_validation->set_rules('displayname','Display Name','required');
 
		if ($this->form_validation->run() == FALSE){
			return false;
		}else{
			return true;
		}         
    }
    
    public function passwordvalidateForm()
    {
		$this->form_validation->set_rules('opass','Old Password','required');
		$this->form_validation->set_rules('pass','Password','required');
		$this->form_validation->set_rules('cpass','Confirm Password','required');

		if ($this->form_validation->run() == FALSE){
			return false;
		}else{
			return true;
		}         
    }
	
}
