<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class admin extends CI_Controller {

 /*
  * Author: Surendra
  * Module : pages
  * adding adduser,update,delete functions
  * 
  */
	public function __construct() 
    {
		parent::__construct();
		//Admin Login Check
		
		if(!adminLoginCheck())
			redirect('admin','refresh'); 
		$this->lang->load("admin",  language_load()); 
		$this->lang->load("admin_pages",  language_load()); 
	}  
	
	// pages listing 
	public function index()
	{    
		 if(!check_perm('page','r'))
		     redirect('admin/permissions/denied');
		$data = array();
		$data = messageDisplay(); 
		$data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
		$data['body'] = $this->load->view('admin_pages_list', $data, true);  
		$this->load->view('admin/layout',$data);
	}
	public function pageslist(){
		
		if(!check_perm('page','r'))
		     redirect('admin/permissions/denied');
		     
		$this->load->library('Datatables');
        $this->load->library('table');
        $this->load->model('admin_page_model');
		echo  $this->admin_page_model->pagelist(); 
		exit;
	}
	
	// add page 
	public function addpage()
	{
		if(!check_perm('page','c'))
		     redirect('admin/permissions/denied');
		     
		$this->getForm(); 
	}
		// edit page
	public function edit() { 
		if(!check_perm('page','u'))
		     redirect('admin/permissions/denied'); 
		     
		$this->getForm(); 
	} 
		// insert page
	public function insert() {
			 
	    if(!check_perm('page','c'))
		     redirect('admin/permissions/denied');
		     
		if($this->pagevalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST') {
				
			$arr=array();
			$arr['page_alias'] = trim($this->input->post('page_alias'));
			$arr['page_title'] = $this->input->post('page_title');
			$arr['page_description']    = $this->input->post('page_description');
			$arr['page_meta_title']    = $this->input->post('page_meta_title');
			$arr['page_meta_keywords']     = $this->input->post('page_meta_keywords');
			$arr['page_meta_description']     = $this->input->post('page_meta_description'); 
			$arr['page_status'] = 'ACTIVE';
			$arr['created_date']    = date('Y-m-d H:i:s');
			$arr['created_by']      =  userdata('admin_id'); 
			$this->load->model('admin_page_model'); 
			$result = $this->admin_page_model->saveData($arr);
				
			if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('admin_pages_insert_success'));
				$this->index();
			} else{
				$this->session->set_userdata('error_msg',$this->lang->line('admin_pages_exists'));
				$this->getForm();
			}	
						
		} else { 
				$this->getForm();
		}
			  
	}
	
	// update page
    public function update() {
		 if(!check_perm('page','u'))
		     redirect('admin/permissions/denied');
		     
		if($this->pagevalidateForm() && $this->input->server('REQUEST_METHOD') == 'POST') {
			
			$arr=array();
			//$arr['page_alias'] = trim($this->input->post('page_alias'));
			$arr['page_title'] = $this->input->post('page_title');
			$arr['page_description']    = $this->input->post('page_description');
			$arr['page_meta_title']    = $this->input->post('page_meta_title');
			$arr['page_meta_keywords']     = $this->input->post('page_meta_keywords');
			$arr['page_meta_description']     = $this->input->post('page_meta_description'); 
			$arr['modified_date']    = date('Y-m-d H:i:s');
			$arr['modified_by']      =  userdata('admin_id'); 
			$arr['page_id']         = $this->input->post('page_id');
				 				 
			$this->load->model('admin_page_model');
			
			$result = $this->admin_page_model->pageUpdate($arr);
			
			if($result){
				$this->session->set_userdata('success_msg',$this->lang->line('admin_pages_update_success'));
  				 redirect('admin/pages');
			}
			else{
				$this->session->set_userdata('error_msg',$this->lang->line('admin_pages_exists'));
  				$this->getForm($this->input->post('page_id'));
			}			
		} 
		else
		{
 			 $this->getForm($this->input->post('page_id'));    
		}
		 
	}
	
    public function getForm($id = '') {
        
        $data=array();
        $data = messageDisplay();
        $data['validate_msgs'] = $this->load->view('admin/validate_message',$data,true); 
        // label data from languages 
		
        $id = $id; 
        if($this->uri->segment(4))
        $id = $this->uri->segment(4);
        
         if ($id!='' && ($this->input->server('REQUEST_METHOD') != 'POST')) {  
			$page_id=$id;
			 
			$this->load->model('admin_page_model');
			$result = $this->admin_page_model->editPage($page_id);
			if($result)
			$page=$result[0];
			else
			{
				 $this->session->set_userdata('error_msg',$this->lang->line('admin_pages_not_exist'));  
				 $this->index();
			}
        		
        }
       
       if ($this->input->post('page_id')) {
        		$data['page_id'] = $this->input->post('page_id');
           } elseif (!empty($page)) {
        		$data['page_id'] = $page->page_id;
           } else {
        		$data['page_id'] = '';
        }
        if ($this->input->post('page_alias')) {
			$data['page_alias'] = $this->input->post('page_alias');
		} elseif (!empty($page)) {
			$data['page_alias'] = $page->page_alias;
		} else {
			$data['page_alias'] = '';
		}
		
		if ($this->input->post('page_title')) {
			$data['page_title'] = $this->input->post('page_title');
		} elseif (!empty($page)) {
			$data['page_title'] = $page->page_title;
		} else {
			$data['page_title'] = '';
		}
		if ($this->input->post('page_description')) {
			$data['page_description'] = $this->input->post('page_description');
		} elseif (!empty($page)) {
			$data['page_description'] = $page->page_description;
		} else {
			$data['page_description'] = '';
		}
		if ($this->input->post('page_meta_title')) {
			$data['page_meta_title'] = $this->input->post('page_meta_title');
		} elseif (!empty($page)) {
			$data['page_meta_title'] = $page->page_meta_title;
		} else {
			$data['page_meta_title'] = '';
		}
		if ($this->input->post('page_meta_keywords')) {
			$data['page_meta_keywords'] = $this->input->post('page_meta_keywords');
		} elseif (!empty($page)) {
			$data['page_meta_keywords'] = $page->page_meta_keywords;
		} else {
			$data['page_meta_keywords'] = '';
		}
		 if ($this->input->post('page_meta_description')) {
			$data['page_meta_description'] = $this->input->post('page_meta_description');
		} elseif (!empty($page)) {
			$data['page_meta_description'] = $page->page_meta_description;
		} else {
			$data['page_meta_description'] = '';
		}
		  
	 
		   
		$data['body'] = $this->load->view('admin_addpage',$data,true);
		$this->load->view('admin/layout',$data);
        	 

        }
   // server side validation     
    public function pagevalidateForm()
        {
           $this->form_validation->set_rules('page_alias','Page alias','required');
           $this->form_validation->set_rules('page_title','Page title','required');
           $this->form_validation->set_rules('page_description','Page Description','required');
           $this->form_validation->set_rules('page_meta_title','Meta title','required');
            $this->form_validation->set_rules('page_meta_keywords','Meta keywords','required');
           $this->form_validation->set_rules('page_meta_description','Meta description','required');
           
           if ($this->form_validation->run() == FALSE){
                 return false;
           }else{
                 return true;
            }
         
    }
	// active pages
	public function active() { 
		 if(!check_perm('page','u'))
		     redirect('admin/permissions/denied');
		      
		$this->load->model('admin_page_model');  
		$result = $this->admin_page_model->activePage($this->input->post('id')); 
		echo "activated";
		exit; 
	}
	// inactive pages
	public function inactive()
	{
		 if(!check_perm('page','u'))
		     redirect('admin/permissions/denied'); 
		     
		$this->load->model('admin_page_model'); 
		$result = $this->admin_page_model->inactivePage($this->input->post('id')); 
		echo "inactivated";
		  exit; 
	}
	// delete pages
	public function delete() { 
		 if(!check_perm('page','d'))
		     redirect('admin/permissions/denied');
		     
		$this->load->model('admin_page_model'); 
		$result = $this->admin_page_model->deletePage($this->input->post('id'));
        echo "deleted";
		exit;
	}
	
 
}
