/**
 *
 * HTML5 Image uploader with Jcrop
 * @author Rushyendra
 * @version 1.0
 * @subversion 1.0
 * @package  
 * @Copyright 2014, 
 * 
 */
/**
 * convert bytes into friendly format
 * @name <bytes_to_size>
 * @param {type} bytes
 * @returns {String}
 * @author Rushyendra
 * @version 1.0
 * @subversion 1.0
 */

function bytes_to_size(bytes) {
    var sizes = ['Bytes', 'KB', 'MB'];
    if (bytes == 0)
        return 'n/a';
    var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
    return (bytes / Math.pow(1024, i)).toFixed(1) + ' ' + sizes[i];
}
;
/**
 * update info by cropping (onChange and onSelect events handler)
 * @name <update_info>
 * @param {type} bytes
 * @returns {String}
 * @author Rushyendra
 * @version 1.0
 * @subversion 1.0
 */
function update_info(e) {
   
    $('#c_x').val(e.x);
    $('#c_y').val(e.y);
    $('#c_x2').val(e.x2);
    $('#c_y2').val(e.y2);
    $('#c_w').val(e.w);
    $('#c_h').val(e.h);
call_canvas(e.x,e.y,e.w,e.h,0,0,100,100,"a");
};
/**
 * Hide the jcrop
 * @name <get_crop>
 * @returns null
 * @author Rushyendra
 * @version 1.0
 * @subversion 1.0
 */
get_crop = function() {
    //$("#preview").parent("div").hide();

    //$("#crop_image_div").html("<img src='' id='crop_image' width='auto' height='auto'>");
    $("#popup_div").html(' <p ><input onClick="get_crop();" type="button" value="crop" id="crop_button" name="crop_button"> <br /></p><div id="popup_div_div" ><img id="preview"  /></div><p>&nbsp; </p>');
    $("#popup_div").hide();
    $(".jcrop-holder").remove();
    $(".jcrop-tracker").remove();
    //$( "#crop_image_div" ).dialog( "destroy" );
}
/**
 Add the slashes for file
 @name <add_slashes>
 @param string str
 @author Rushyendra
 @version 1.0
 @subversion 1.0
 */
function add_slashes(str) {
    str = str.replace(/\\/g, '\\\\');
    str = str.replace(/\'/g, '\\\'');
    str = str.replace(/\"/g, '\\"');
    str = str.replace(/\0/g, '\\0');
    // str = str.replace(/\\\\/g, '\\\\');
    return str;
}
/**
 Perform the file operation in IE
 @name <change_img>
 @param string str
 @param string file_name
 @author Rushyendra
 @version 1.0
 @subversion 1.0
 */
function change_img(str, file_name) {

    str = add_slashes(str);
    var org_imagePreview = document.getElementById('preview');
    // var file1 = system_path + "assets/images/uploads/news/tmp/" + file_name;
    file1 = base_url + "assets/images/uploads/news/tmp/" + file_name;
    org_imagePreview.src = file1;
    $("#popup_div").show();
    var org_image = document.getElementById('target_image');
     news_image = file1;
    org_image.src = file1;
    org_image.width = "100";
    org_image.height = "100";
    call_jcrop();
    return false;

}

// Create variables (in this scope) to hold the Jcrop API and image size
var jcrop_api, boundx, boundy;
/**
 Perform the cropping on change the  image
 @name <file_select_handler>
 @author Rushyendra
 @version 1.0
 @subversion 1.0
 */
function file_select_handler() {
    $('#file_validation').hide();
    var file_size = get_file_size("news_image");
    var org_file = document.getElementById("news_image").value;
    var file_img = org_file;
    var pos = org_file.lastIndexOf(".");
    if (pos != -1) {
        var ext = org_file.slice(pos + 1);
        ext = ext.toLowerCase();
        if (ext != "jpg" && ext != "jpeg" && ext != "gif" && ext != "png")
        {
            $('#file_validation').html('Please select a valid image file (jpg,gif and png are allowed)').show();
            return false;
        }
    }
    if (file_size > 2 * 1024 * 1024) {
        $('#file_validation').html('You have selected too big file, please select a one smaller image file').show();
        return false;
    }
    if ($('#news_image')[0].files) {
        var org_file = $('#news_image')[0].files[0];

    } else {
        // var org_file = $('#news_image')[0].val();
        var org_file = document.getElementById("news_image").value;
        var file_name = copy_files(org_file);
        change_img(file_img, file_name);
        return false;

    }
// preview element
    var org_image = document.getElementById('preview');
    if (window.FileReader) {
        // prepare HTML5 FileReader
        var org_reader = new FileReader();
        org_reader.onload = function(e) {
            // e.target.result contains the DataURL which we can use as a source of the image
            org_image.src = e.target.result;
            org_image.onload = function() { // onload event handler
                // display some basic image info
                var file_size = bytes_to_size(org_file.size);
                var org_image_target = document.getElementById('target_image');
                $("#popup_div").show();
               org_image_target.src = e.target.result;
               news_image = e.target.result;
                // destroy Jcrop if it is existed
                if (typeof jcrop_api != 'undefined') {
                    jcrop_api.destroy();
                    jcrop_api = null;
                }    //undefined closed
                $('#preview').width(org_image.naturalWidth);
                $('#preview').height(org_image.naturalHeight);
                call_jcrop();
            };  //image on load
        };                     //Reader on load
        // read selected file as DataURL
        org_reader.readAsDataURL(org_file);
    }
}
/**
 Call jcrop
 @name <call_jcrop>
 @author Rushyendra
 @version 1.0
 @subversion 1.0
 */
call_jcrop = function()
{
    // initialize Jcrop
    $('#preview').Jcrop({
        // minSize: [350, 230], // min crop size
         setSelect: [0, 0, 350, 230],
        aspectRatio: 35 / 23, // keep aspect ratio 1:1
       // allowResize: true,
        keySupport: true,
        bgFade: true, // use fade effect
        bgOpacity: .3, // fade opacity
        onSelect: update_info,
        onChange: update_info
        
    }, function() {
        // use the Jcrop API to get the real image size
        var bounds = this.getBounds();
        boundx = bounds[0];
        boundy = bounds[1];
        // Store the Jcrop API in the jcrop_api variable
        jcrop_api = this;
    });
  if(window.addEventListener)
{
    window.addEventListener("load",call_canvas(0,0,350,230,0,0,100,100,"b"),false);
}
else if(window.attachEvent)
{
    attachEvent("onload",call_canvas(0,0,350,230,0,0,100,100,"b"));
}
}
/**
 Copy the file into temporary file for IE
 @name <copy_files>
 @param string fileid
 @author Rushyendra
 @version 1.0
 @subversion 1.0
 */
copy_files = function(fileid) {
    //please make sure ActiveX is enabled in your IE browser
    var file_name = "";
    var obj_fso = new ActiveXObject("Scripting.FileSystemObject");
    var file_path = fileid;
    file_name = obj_fso.GetFileName(file_path);
    obj_fso.CopyFile(file_path, system_path + "assets/images/uploads/news/tmp/" + file_name); //size in kb
    $("#delete_file_tmp").val(file_name);
    return file_name;
}
/**
 * Get the file size
 * @name <get_file_size>
 * @param string str
 * @return int
 * @author Rushyendra
 * @version 1.0
 * @subversion 1.0
 */
function get_file_size(fileid) {
    try {
        var file_size = 0;
        //for IE
        if (navigator.userAgent.match(/msie/i)) {
            var file_path = $("#" + fileid).val();
            var obj_fso;
            //before making an object of ActiveXObject,
            //please make sure ActiveX is enabled in your IE browser

            obj_fso = new ActiveXObject("Scripting.FileSystemObject");

            var obj_file = obj_fso.GetFile(file_path);

            file_size = obj_file.size; //size in kb

            //fileSize = fileSize / 1048576; //size in mb
        }
        //for FF, Safari, Opeara and Others
        else {
            file_size = $("#" + fileid)[0].files[0].size //size in kb
            //fileSize = fileSize / 1048576; //size in mb
        }
        return file_size;
    }
    catch (e) {
       return 0;
    }
}
/**
 * Create the image 
 * @param int clip_x
 * @param int clip_y
 * @param int clip_w
 * @param int clip_h
 * @param int org_x
 * @param int org_y
 * @param int org_w
 * @param int org_h
 * @param string type
 * @returns void
 * @author Rushyendra
 * @version 1.0
 * @subversion 1.0
 */
call_canvas =function(clip_x,clip_y,clip_w,clip_h,org_x,org_y,org_w,org_h,type){
  
//var img=document.getElementById("target_image");
var img = new Image();
  img.src = news_image;
   if(type== "b"){
    clip_w = img.width;
    clip_h = img.height;
   }
  /* if(navigator.appName=="Microsoft Internet Explorer"){
         //img.onload =function(){
             var c=document.getElementById("canvas_img");
//var ctx=c.getContext("2d");
//$("#canvas_image").src= img.src;

//if(clip_x ==0) clip_x =1;
//if(clip_y ==0) clip_y =1;
//alert(clip_x);
//ctx.drawImage(img,clip_x,clip_y,clip_w,clip_h,org_x,org_y,org_w,org_h);
         //}       
   }else{*/
     var c=document.getElementById("canvas_img");
var ctx=c.getContext("2d");

ctx.drawImage(img,clip_x,clip_y,clip_w,clip_h,org_x,org_y,org_w,org_h);
   //}

}
//call the image
/*if(navigator.appName=="Microsoft Internet Explorer"){
   call_canvas(0,0,350,230,0,0,100,100,"b"); 
}else{*/
$(document).ready(function(){
    call_canvas(1,1,350,230,10,10,100,100,"b");
    $("#canvas_img").show();
});
//}
